#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 7;

double lx[MAXN] , ly[MAXN] , ux[MAXN] , uy[MAXN];
double sx[MAXN] , sy[MAXN];

int n , m;


void read()
{
    scanf ( "%d%d" , &n , &m );

    int i;
    double x1 , y1 , x2 , y2;
    for (i = 0; i < n; ++i)
    {
        scanf ( "%lf%lf%lf%lf" , &x1 , &y1 , &x2 , &y2 );
        lx[i] = min ( x1 , x2 );
        ly[i] = min ( y1 , y2 );

        ux[i] = max ( x1 , x2 );
        uy[i] = max ( y1 , y2 );
    }
    for (i = 0; i < m; ++i)
        scanf ( "%lf%lf" , sx + i , sy + i );
}

bool inside ( int id )
{
    int i , j;
    int res = 0;

    for (i = 0; i < n; ++i)
    {
        if ( lx[i] < sx[id] && ly[i] < sy[id] && ux[i] > sx[id] && uy[i] > sy[id] )
            return 1;

        //if ( sx[id] == lx[i] || sx[id] == ux[i] ) ++res;
        //if ( sy[id] == ly[i] || sy[id] == uy[i] ) ++res;

        //if ( (sx[id] == lx[i] || sx[id] == ux[i]) && ( sy[id] == ly[i] || sy[id] == uy[i] ) )
          //  res -= 2;
    }


    return 0;//(res >> 1) > 0;
}

void solve()
{
    int res = 0;

    int i;
    for (i = 0; i < m; ++i)
        if ( inside ( i ) )
        {
            ++res;
        }

    printf ( "%d\n" , res );
}

int main()
{
    read();
    solve();

    return 0;
}
