/*
PROB: shepherd
LANG: C++
KEYW: 
*/
/// Thanks to Him I can know and learn! Love Christ!
/// "Without Me you can do nothing" ( John 15:5 )
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cstring>
#include <queue>
#include <ctime>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <numeric>
#include <algorithm>
#define foreach(_var,_container) for( typeof( (_container).begin() ) _var = (_container).begin() ; _var != (_container).end() ; ++_var )
#define now() double( double( clock() ) / double( CLOCKS_PER_SEC ) )
#if 1
#define eprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )
#else
#define eprintf(msg, ... ) 0
#endif
#define pprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )

typedef long long ll;

using namespace std;

const int MAXN = 1 << 7;

struct rect{
    double xi, yi, xj, yj;
};

struct point{
    double x, y;
};

inline bool between( double a , double m , double b ){
    return a < m and m < b;
}

inline bool inside( const struct rect &x , const struct point &p ){
    return between( x.xi , p.x , x.xj ) and between( x.yi , p.y , x.yj );
}

int F, S;
rect r[MAXN];
point s[MAXN];

void read(){
    scanf("%d %d", &F, &S); /// fences, sheep
    
    for( int i = 0 ; i < F ; i++ ){
        double a, b, c, d;
        scanf("%lf %lf %lf %lf", &a, &b, &c, &d);
        
        r[i].xi = min( a , c );
        r[i].xj = max( a , c );
        
        r[i].yi = min( b , d );
        r[i].yj = max( b , d );
    }
    
    for( int i = 0 ; i < S ; i++ )
        scanf("%lf %lf", &s[i].x, &s[i].y);
}

void solve(){
    int answer = 0;
    
    for( int i = 0 ; i < S ; i++ ){
        int runaway = 1;
        for( int j = 0 ; j < F ; j++ )
            if( inside( r[j] , s[i] ) )
                runaway = 0;
        answer += runaway;
    }
    
    printf("%d\n", S - answer);
}

int main(){
    //freopen( "3.in" , "r" , stdin );
    //freopen( "3.out" , "w" , stdout );
    
    read();
    ///init();
    solve();
    
    return 0;
}
