/*
PROB: calc
LANG: C++
KEYW: 
*/
/// Thanks to Him I can know and learn! Love Christ!
/// "Without Me you can do nothing" ( John 15:5 )
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cstring>
#include <queue>
#include <ctime>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <numeric>
#include <algorithm>
#define foreach(_var,_container) for( typeof( (_container).begin() ) _var = (_container).begin() ; _var != (_container).end() ; ++_var )
#define now() double( double( clock() ) / double( CLOCKS_PER_SEC ) )
#if 1
#define eprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )
#else
#define eprintf(msg, ... ) 0
#endif
#define pprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )

typedef long long ll;

using namespace std;

const int MAXN = 1 << 5;
const int CODES[] = { 126 , 48 , 109 , 121 , 51 , 91 , 95 , 112 , 127 , 123 };

int N;
int code[MAXN];

void read(){
    scanf("%d", &N);
    
    for( int i = 0 ; i < N ; i++ ){
        char buff[16];
        scanf("%s", buff);
        
        eprintf("Code -> %s", buff);
        
        for( int j = 0 ; j < 7 ; j++ )
            if( buff[j] == '1' )
                code[i] |= 1 << (6 - j);
    }
}

vector<int> possible[MAXN];

int now[MAXN];

void get( int at ){
    if( at == N ){
        for( int i = 0 ; i < N ; i++ )
            printf("%d", possible[i][ now[i] ]);
        printf("\n");
        return;
    }else{
        for( int i = 0 ; i < possible[at].size() ; i++ ){
            now[at] = i;
            get( at + 1 );
        }
    }
}

void solve(){
    int answer = 1;
    
    for( int i = 0 ; i < N ; i++ ){
        int ways = 0;
        for( int j = 0 ; j <= 9 ; j++ )
            if( (code[i] & CODES[j]) == code[i] ){
                ways++;
                eprintf("Code #%d(%d) -> %d", i + 1, code[i], j);
                possible[i].push_back( j );
            }
        answer *= ways;
    }
    
    printf("%d\n", answer);
    get( 0 );
}

int main(){
    //freopen( "4.in" , "r" , stdin );
    //freopen( "4.out" , "w" , stdout );
    
    read();
    ///init();
    solve();
    
    return 0;
}
