/*
PROB: knights
LANG: C++
KEYW: 
*/
/// Thanks to Him I can know and learn! Love Christ!
/// "Without Me you can do nothing" ( John 15:5 )
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cstring>
#include <queue>
#include <ctime>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <numeric>
#include <algorithm>
#define foreach(_var,_container) for( typeof( (_container).begin() ) _var = (_container).begin() ; _var != (_container).end() ; ++_var )
#define now() double( double( clock() ) / double( CLOCKS_PER_SEC ) )
#if 0
#define eprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )
#else
#define eprintf(msg, ... ) 0
#endif
#define pprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )

typedef long long ll;

using namespace std;

const int MAXA = 5;
const int MAXN = 1 << 6;

int A, B, C, D;

ll dp[MAXN][2][1 << MAXA][1 << MAXA];

ll get( int pos , int type , int a , int b ){
    if( pos > C )
        return 0;
    
    if( !a and !b ){
        if( type == 1 ) /// as the first is 0 the next cannot be 1
            return 0;
        
        if( pos > C ) /// out of range
            return 0;
        else if( pos < C ) /// OK
            return 1;
        else if( pos == C ) /// at 0 should a 0 be put
            return 1;
    }
    
    ll &self = dp[pos][type][a][b];
    
    if( self != -1 )
        return self;
    
    self = 0;
    
    // don't put it here
    if( pos != 0 )
        self += get( pos + 1 , type , a , b );
    
    if( type == 0 and !a ) return 0;
    if( type == 1 and !b ) return 0;
    
    // put it here
    if( type == 0 ){
        int lim = (pos == 0 ? 1 : A);
        for( int i = 0 ; i < lim ; i++ )
            if( ( 1 << i ) & a ){
    //          for( int j = pos + 1 ; j <= C ; j++ )
                self += get( pos + 1 , 0 , a ^ ( 1 << i ) , b );
    //          for( int j = pos + D ; j <= C ; j++ )
                self += get( pos + D , 1 , a ^ ( 1 << i ) , b );
            }
    }else{
        for( int i = 0 ; i < B ; i++ )
            if( ( 1 << i ) & b ){
    //          for( int j = pos + 1 ; j <= C ; j++ )
                self += get( pos + 1 , 1 , a , b ^ ( 1 << i ) );
    //          for( int j = pos + D ; j <= C ; j++ )
                self += get( pos + D , 0 , a , b ^ ( 1 << i ) );
            }
    }
    
    eprintf("DP(pos = %d(%d), a = %d, b = %d) -> %d", pos, type, a, b, self);
    
    return self;
}

void read(){
    scanf("%d %d %d %d", &A, &B, &C, &D);
}

void solve(){
    const int ALLA = ( 1 << A ) - 1;
    const int ALLB = ( 1 << B ) - 1;
    
    memset( dp , -1 , sizeof( dp ) );
    
    printf("%lld\n", C * get( 0 , 0 , ALLA , ALLB ) );
}

int main(){
    //freopen( "8.in" , "r" , stdin );
    //freopen( "8.out" , "w" , stdout );
    
    read();
    ///init();
    solve();
    
    return 0;
}
