#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

int num[10][7] = 
{
//    A, B, C, D, E, F ,G
	{ 1, 1, 1, 1, 1, 1, 0 }, //0
	{ 0, 1, 1, 0, 0, 0, 0 }, //1
	{ 1, 1, 0, 1, 1, 0, 1 }, // 2
	{ 1, 1, 1, 1, 0, 0, 1 }, // 3
	{ 0, 1, 1, 0, 0, 1, 1 }, // 4
	{ 1, 0, 1, 1, 0, 1, 1 }, // 5
	{ 1, 0, 1, 1, 1, 1, 1 }, // 6
	{ 1, 1, 1, 0, 0, 0, 0 }, // 7
	{ 1, 1, 1, 1, 1, 1, 1 }, // 8
	{ 1, 1, 1, 1, 0, 1, 1 }, // 9
};

void printAll(const vector<vector<int> > P, string& s, int pos)
{
	for(int i = 0; i < P[pos].size(); i++)
	{
		if(pos == P.size() - 1)
		{
			printf("%s%c\n", s.c_str(), P[pos][i] + '0');
		}
		else 
		{
			s += P[pos][i] + '0';
			printAll(P, s, pos + 1);
			s.erase(s.size() - 1);
		}
	}
}

vector<vector<int> > P;
vector<string> v;

int main()
{
	//freopen("in.txt", "r", stdin);
	int N;
	scanf("%d", &N);
	P.resize(N);
	v.resize(N);
	int p; bool found;
	char buf[10];
	for(int i = 0; i < N; i++)
	{
		scanf("%s", buf);
		v[i] = buf;
		for(int k = 0; k < 10; k++)
		{
			found = true;
			for(int j = 0; j < v[i].size(); j++)
			{
				p = v[i][j] - '0';
				if(!num[k][j] && p)
				{ 
					found = false; 
					break;
				}
			}
			if(found)
				P[i].push_back(k);
		}
	}
	int ans = 1;
	for(int i = 0; i < P.size(); i++)
	{
		ans *= P[i].size();
	}
	string s;
	printf("%d\n", ans);
	printAll(P, s, 0);
	return 0;
}