using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace _3.Sheeps
{
	class Sheeps
	{
		static void Main(string[] args)
		{
			string[] fs = Console.ReadLine().Split(' ');
			int f = int.Parse(fs[0]);
			int s = int.Parse(fs[1]);

			double[,] fences = new double[f, 4];
			double[,] sheeps = new double[s, 2];
			for (int i = 0; i < f; i++)
			{
				string[] fenceInfo = Console.ReadLine().Split(' ');
				for (int j = 0; j < fenceInfo.Length; j++)
				{
					fences[i, j] = double.Parse(fenceInfo[j]);
				}
			}
			for (int i = 0; i < s; i++)
			{
				string[] sheepInfo = Console.ReadLine().Split(' ');
				sheeps[i, 0] = double.Parse(sheepInfo[0]);
				sheeps[i, 1] = double.Parse(sheepInfo[1]);
			}

			int total = 0;
			for (int i = 0; i < sheeps.GetLength(0); i++)
			{
				double currentX = sheeps[i, 0];
				double currentY = sheeps[i, 1];
				bool isIn = false;
				for (int j = 0; j < fences.GetLength(0); j++)
				{
					if (((currentX > fences[j, 0] && currentX < fences[j, 2]) || (currentX < fences[j, 0] && currentX > fences[j, 2])) &&
						((currentY > fences[j, 1] && currentY < fences[j, 3]) || (currentY < fences[j, 1] && currentY > fences[j, 3])))
					{
						isIn = true;
						break;
					}
				}
				if (isIn)
				{
					total++;
				}
			}
			Console.WriteLine(total);
		}
	}
}
