#include <iostream>
#include <queue>
#include <vector>
#define MAX 20000000
using namespace std;

struct edge
{
       int u,v;
       edge(){}
       edge(int _u, int _v)
       {
                u=_u;
                v=_v;
       }
       bool operator<(const edge &a)
       const{
             return v>a.v;
             }
};

vector<edge> a[20000];
vector<int> H;
priority_queue<edge> q;
int d[20000];
bool ish[20000];
bool used[20000];
int n,m,h;

int go(int p)
{
    //cout << p << endl;
    for(int i=0; i<=n; i++){
             d[i]=MAX;
             used[i]=0;
             }
    d[p]=0;
    q.push(edge(p,0));
    while(!q.empty())
    {
                     edge curr=q.top();
                     int cu=curr.u, cv=curr.v;
                     q.pop();
                     if(used[cu]) continue;
                     used[cu]=1;
                     for(int i=0; i<a[cu].size(); i++)
                     {
                             int zu=a[cu][i].u;
                             int zv=a[cu][i].v;
                             if(d[cu]+zv<d[zu]) {
                                              d[zu]=d[cu]+zv;
                                              q.push(edge(zu,d[zu]));
                                              }
                     }
    }
    
    int res=0;
    for(int i=1; i<=n; i++)
    if(!ish[i]) res+=d[i];
    return res;
}

int main()
{
    cin >> n >> m >> h;
    int x,y,d,t;
    for(int i=0; i<h; i++)
    {
            cin >> t;
            ish[t]=1;
            H.push_back(t);
    }
    
    for(int i=0; i<m; i++)
    {
            cin >> x >> y >> t;
            a[x].push_back(edge(y,t));
            a[y].push_back(edge(x,t));
    }
    
    int res=go(H[0]);
    for(int i=1; i<h; i++)
    {
            int curr=go(H[i]);
            res=min(res,curr);
    }
    cout << res << endl;
    return 0;
}
    
