#include <iostream>
#include <cmath>
using namespace std;

struct point
{
       double x,y;
       point(){}
       point(double _x, double _y)
       {
                    x=_x;
                    y=_y;
       }
}a[512000];

struct poly
{
       point v[512];
}p[512];



double det(point M, point N)
{
       return M.x*N.y-N.x*M.y;
}
       


bool check(point A, poly P, int c)
{
     double sp=0.0, spa=0.0;
     
     for(int i=0; i<c-1; i++)
     {
             //cout << P.v[i].x << ' ' << P.v[i].y << ' ' << P.v[i+1].x << ' ' << P.v[i+1].y << endl;
             sp+=det(P.v[i],P.v[i+1]);
             spa+=abs((det(P.v[i],P.v[i+1])+det(P.v[i+1],A)+det(A,P.v[i]))/2.0);
     }
     sp+=det(P.v[c-1], P.v[0]);
     spa+=abs((det(P.v[c-1],P.v[0])+det(P.v[0],A)+det(A,P.v[c-1]))/2.0);
     sp/=2.0;
     //cout << sp << ' ' << spa << endl;
     if(abs(sp)==abs(spa)) return true;
     return false;
}
     

bool hit[512];

int main()
{
    int b, s, c[512];
    cin >> b >> s;
    double x,y;
    for(int i=0; i<b; i++)
    {
               cin >> c[i];
               for(int j=0; j<c[i]; j++)
               {
                       cin >> x >> y;
                       p[i].v[j]=point(x,y);
               }
    }
    
    for(int i=0; i<s; i++)
    {
            cin >> x >> y;
            a[i]=point(x,y);
    }
    
    int res=0;
    for(int i=0; i<s; i++)
    {
            for(int j=0; j<b; j++)
            if(check(a[i],p[j],c[j])) hit[j]=true;
    }
    
    for(int j=0; j<b; j++) 
    if(hit[j]==true) res++;
    
    cout << res << endl;
    return 0;
}
    
