#include <cstdio>
#include <queue>

#define MAX_VALUE 1000000
#define BASE 100000

using namespace std;

struct edge
{
    int x,w;
};

struct vertex
{
    int i,d;
};

int hos[128],d[10006],used[10006];
vector <edge> a[10006];
priority_queue<long long>q;

int main()
{
    edge l;
    vertex t;
    long long t1,curr1;
    int i,j,k,n,m,h,x,y,w,mini = MAX_VALUE,sum;
    scanf ("%d%d%d",&n,&m,&h);
    for ( i=1; i<=h; i++ ) scanf ("%d",&hos[i]);
    for ( i=1; i<=m; i++ )
    {
        scanf ("%d%d%d",&x,&y,&w);
        l.x = y; l.w = w;
        a[x].push_back(l);
        l.x = x;
        a[y].push_back(l);
    }

    for ( i=1; i<=h; i++ )
    {
        for ( j=1; j<=n; j++ )
        {
            used[j] = 0;
            d[j] = MAX_VALUE;
        }
        d[ hos[i] ] = 0;
        t.i = hos[i];
        t.d = 0;
        t1 = t.d * BASE + t.i;
        q.push(-t1);
        while (1)
        {
            t.i = -1;
            while ( !q.empty() )
            {
                t1 = -q.top();
                t.i = t1%BASE;
                t.d = t1/BASE;
                q.pop();
                if ( !used[ t.i ] ) break;
            }
            if ( t.i == -1 ) break;
            used[ t.i ] = 1;

            for ( j=0; j<a[t.i].size(); j++ )
                if ( d[ a[t.i][j].x ] > t.d + a[t.i][j].w )
                {
                    d[ a[t.i][j].x ] = t.d + a[t.i][j].w;
                    vertex curr;
                    curr.d = d[ a[t.i][j].x ];
                    curr.i = a[t.i][j].x;
                    curr1 = curr.d*BASE + curr.i;
                    q.push(-curr1);
                }
        }

        sum = 0;
        for ( j=1; j<=n; j++ )
            sum += d[j];
        for ( j=1; j<=h; j++ )
            sum -= d[ hos[j] ];
        if ( sum < mini ) mini = sum;
    }

    printf ("%d\n",mini);
}
