using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

class SevenSegmentDisplay
{
    static byte[] digits = new byte[]{
        Convert.ToByte("1111110", 2),
        Convert.ToByte("0110000", 2),
        Convert.ToByte("1101101", 2),
        Convert.ToByte("1111001", 2),
        Convert.ToByte("0110011", 2),
        Convert.ToByte("1011011", 2),
        Convert.ToByte("1011111", 2),
        Convert.ToByte("1110000", 2),
        Convert.ToByte("1111111", 2),
        Convert.ToByte("1111011", 2),
    };
    static int posibleCombinations;
    static StringBuilder currentNumber = new StringBuilder();
    static int n;
    static List<byte> displayElements = new List<byte>();
    static List<string> rezult = new List<string>();
    static void Main(string[] args)
    {
        n = int.Parse(Console.ReadLine());
       
        for (int i = 0; i < n; i++)
        {
            displayElements.Add(Convert.ToByte(Console.ReadLine(),2));
        }

        SolveDigits(0);
        Console.WriteLine(posibleCombinations);
        foreach (string number in rezult)
        {
            Console.WriteLine(number);
        }

    }

    static void SolveDigits(int counter)
    {
        if (counter==n)
        {
            posibleCombinations++;
            rezult.Add(currentNumber.ToString());
            
            return;
        }

        for (int i = 0; i < 10; i++)
        {
            if ((digits[i] & displayElements[counter]) == displayElements[counter])
            {
                currentNumber.Append(i);
                SolveDigits(counter+1);
                currentNumber.Remove(counter, 1);
            }
        }
    }
}