using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace _03.JoroTheShepherd
{
    class JoroTheShepherd
    {
        struct RecPosition
        {
            public decimal x1;
            public decimal x2;
            public decimal y1;
            public decimal y2;
        }
        struct SheepPosotion
        {
            public decimal x;
            public decimal y;
        }
        static void Main()
        {
            string line = Console.ReadLine();
            string[] inputs = line.Split();
            int fencesCount = int.Parse(inputs[0]);
            int sheepsCount = int.Parse(inputs[1]);

            List<RecPosition> rectangs = new List<RecPosition>();
            for (int i = 0; i < fencesCount; i++)
            {
                string[] recCord = Console.ReadLine().Split();
                decimal x1 = decimal.Parse(recCord[0]);
                decimal x2 = decimal.Parse(recCord[2]);
                decimal y1 = decimal.Parse(recCord[1]);
                decimal y2 = decimal.Parse(recCord[3]);
                RecPosition pos = new RecPosition();
                pos.x1 = Math.Min(x1, x2);
                pos.x2 = Math.Max(x1, x2);
                pos.y1 = Math.Min(y1, y2);
                pos.y2 = Math.Max(y1, y2);
                rectangs.Add(pos);
            }
            List<SheepPosotion> sheeps = new List<SheepPosotion>();
            for (int i = 0; i < sheepsCount; i++)
            {
                string inLine = Console.ReadLine();
                string[] sheepCord = inLine.Split();
                decimal x = decimal.Parse(sheepCord[0]);
                decimal y = decimal.Parse(sheepCord[1]);
                SheepPosotion pos = new SheepPosotion();
                pos.x = x;
                pos.y = y;
                sheeps.Add(pos);
            }

            int sheepsIn = 0;
            for (int i = 0; i < rectangs.Count; i++)
            {
                for (int j = 0; j < sheeps.Count; j++)
                {
                    if (sheeps[j].x < rectangs[i].x2 && sheeps[j].x > rectangs[i].x1 &&
                        sheeps[j].y < rectangs[i].y2 && sheeps[j].y > rectangs[i].y1)
                    {
                        SheepPosotion pos = new SheepPosotion();
                        pos.x = decimal.MaxValue;
                        pos.y = decimal.MaxValue;
                        sheeps[j] = pos;
                        sheepsIn++;
                    }
                }
            }
            Console.Write(sheepsIn);
        }
    }
}