using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace _09.Domino.cs
{
    class Program
    {
        static void Main()
        {
            string[] input = Console.ReadLine().Split();
            int rows = int.Parse(input[0]);
            int cols = int.Parse(input[1]);

            char[,] table = new char[rows,cols];
            for (int row = 0; row < rows; row++)
            {
                string line = Console.ReadLine();
                for (int col = 0; col < cols; col++)
                {
                    table[row, col] = line[col];
                }
            }
            int minDistaance = int.MinValue;

            for (int row = 0; row < rows; row++)
            {
                for (int col = 0; col < cols; col++)
                {
                    if(table[row,col] == 'x')
                    {
                        for (int i = 0; i < rows; i++)
                        {
                            for (int j = 0; j < cols; j++)
                            {
                                if (table[i, j] == '*')
                                {
                                    int distance = (row - i)*(row - i) +(col - j)*(col - j);
                                    if (distance>minDistaance)
                                    {
                                        minDistaance=distance;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            Console.Write("{0:f6}",Math.Sqrt(minDistaance));

        }
    }
}