#include <iostream>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cstdio>
using namespace std;

#define MAX 1000

char g[MAX][MAX];

int m,n;
struct dist {
    int x,y;
    int x2,y2;
    double dist;
} p[10000000];

struct kuldist {
    int x,y;
    int x2,y2;
    double dist;
}  kul[10000000], a,b;
int distcnt = 0;
int kulcnt = 0;

bool operator<(dist a, dist b) {
    if (a.dist < b.dist) {
        return true;
    }
    return false;
}

void input() {
    cin >> m >> n;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> g[i][j];
        }
    }
}
/*
3 3
*.*
.x.
*.*

2 6
*.***.
x.x.x.
*/

void find_distances(int i, int j) {
    for (int k = 0; k < m; ++k) {
        for (int z = 0; z < n; ++z) {
            if (g[k][z] == 'x') {
                p[distcnt].x = i;
                p[distcnt].y = j;
                p[distcnt].x2 = k;
                p[distcnt].y2 = z;
                p[distcnt].dist = sqrt((i-k)*(i-k) + (j-z)*(j-z));
                ++distcnt;
            }
            if ((k != i || z != j) && g[k][z] == '*') {
                kul[kulcnt].x = i;
                kul[kulcnt].y = j;
                kul[kulcnt].x2 = k;
                kul[kulcnt].y2 = z;
                kul[kulcnt].dist = sqrt(((i-k)*(i-k) + (j-z)*(j-z)));
                ++kulcnt;
                //cout << i << " " << j << " " << k << " " << z << endl;
             }
        }
    }
}
void solve() {
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (g[i][j] == '*') {
                find_distances(i,j);
            }
        }
    }
    //sort(p,p+distcnt);
    double minAST = 1000000.0;
    for (int i = 0; i < kulcnt; ++i) {
        //cout << fabs(kul[i].y-kul[i].y2) << endl;
        if (fabs(kul[i].x-kul[i].x2)>1 || fabs(kul[i].y-kul[i].y2)>1) {
            if (kul[i].dist < minAST) {
                minAST = kul[i].dist;
            }
        }
    }/*
    for (int i = 0; i < distcnt; ++i) {
        double cl = p[i].dist;
        for (int j = 0; j < kulcnt; ++j) {
            if (cl>kul[j]) {

            }
        }
    }
    */
    double ans = 0.0;
    for (int i = 0; i < distcnt; ++i) {
        ans+=p[i].dist;
    }
    printf("%0.6f\n",ans/(double)(distcnt));
}

int main() {
    input();
    solve();
    return 0;
}