#include <string>
#include <vector>
#include <iostream>
#include <string.h>
#include <math.h>
#include <set>
#include <algorithm>
using namespace std;

long long DP[64][128];
int M, K, N;

bool covers(int pos, int address)
{
     return pos <= address && pos + K - 1 >= address;
}

int main() 
{
    cin >> M >> K >> N;

    vector<int> adds, pos;
    for (int i = 0; i < N; i++)
    {
        int add;
        cin >> add;
        adds.push_back(add);
        pos.push_back(min(add, M - K + 1));
        pos.push_back(max(0, add - K + 1));
    }
    sort(pos.begin(), pos.end());
    
    memset(DP, 8, sizeof(DP));      
    for (int i = 0; i < pos.size(); i++) 
        if (covers(pos[i], adds[0])) 
           DP[0][i] = K;
    
    long long ans = DP[1][1];
    for (int i = 1; i < N; i++)
        for (int j1 = 0; j1 < pos.size(); j1++) if (covers(pos[j1], adds[i-1]))
            for (int j2 = 0; j2 < pos.size(); j2++) if (covers(pos[j2], adds[i]))
            {
                int l = max(pos[j1], pos[j2]);
                int r = min(pos[j1] + K - 1, pos[j2] + K - 1);
            
                long long common = r < l ? 0 : r - l + 1;
            
                DP[i][j2] = min(DP[i][j2], DP[i-1][j1] + K - common);
                if (i == N - 1) 
                   ans = min(ans, DP[i][j2]);
            }
            
    cout << (N == 1 ? K : ans) << endl;
}
