#include <cstdio>
#include <algorithm>
#define MAXN (1 << 7)
#define EPS (1e-10)
using namespace std;

typedef double dbl;

int n, m;
dbl minx[MAXN], maxx[MAXN];
dbl miny[MAXN], maxy[MAXN];
dbl x[MAXN], y[MAXN];

inline void solve() {
	int sol = 0;
	//printf("into the solve %d %d\n", n, m);
	for (int i=0; i < m; ++i) {
		for (int j=0; j < n; ++j) {
			if ((minx[j]+EPS < x[i]) && x[i]+EPS < maxx[j])
				if (miny[j]+EPS < y[i] && y[i]+EPS < maxy[j]) {
					sol ++;
					break;
				}
		}
	}

	printf("%d\n", sol);
}

inline void read() {
	scanf("%d%d", &n, &m);
	for (int i=0; i < n; ++i) {
		dbl ax, ay, bx, by;
		scanf("%lf%lf%lf%lf", &ax, &ay, &bx, &by);
		if (ax > bx+EPS) swap(ax, bx);
		if (ay > by+EPS) swap(ay, by);
		minx[i] = ax; maxx[i] = bx;
		miny[i] = ay; maxy[i] = by;
	}

	for (int i=0; i < m; ++i) {
		scanf("%lf%lf", &x[i], &y[i]);
	}
}

int main() {
	read();
	solve();
	return 0;
}
