#include <cstdio>
#include <vector>
#include <string>
#define MAXN (1 << 5)
using namespace std;

char s[MAXN];
vector<int> masks;
vector<int> num;

int n;
const int sz = 7;
int total = (1 << sz) - 1;

vector<int> vec[MAXN];
vector<long long> all;

inline void add() {
	num.push_back(total ^ (1 << 6)); // 0
	num.push_back((1 << 2) | (1 << 1)); // 1
	num.push_back(total ^ (1 << 5) ^ (1 << 2)); // 2
	num.push_back(total ^ (1 << 4) ^ (1 << 5));
	num.push_back(total ^ (1 << 0) ^ (1 << 3) ^ (1 << 4));
	num.push_back(total ^ (1 << 1) ^ (1 << 4));
	num.push_back(total ^ (1 << 1));
	num.push_back(num[1] | (1 << 0));
	num.push_back(total);
	num.push_back(total ^ (1 << 4));
}

inline void print(long long x) {
	string str; str.clear();
	for (int i=0; i < n; ++i) str += '0';

	int idx = str.size()-1;
	while (x) {
		str[idx--] = (x % 10) + '0';
		x /= 10LL;
	}

	printf("%s\n", str.c_str());
}

void go(int cur, long long num) {
	if (cur == n) {
		all.push_back(num);
		return;
	}
	for (int i=0; i < vec[cur].size(); ++i) {
		go(cur+1, num*10LL + vec[cur][i]);
	}
}

inline void solve() {
	add();
	for (int i=0; i < masks.size(); ++i) {
		for (int j=0; j < num.size(); ++j) if ((masks[i] & num[j]) == masks[i]) {
			vec[i].push_back(j);
		}
	}

	go(0, 0LL);
	printf("%d\n", all.size());
	for (int i=0; i < all.size(); ++i)
		print(all[i]);
}

inline void read() {
	scanf("%d", &n);
	for (int i=0; i < n; ++i) {
		scanf("%s", s);

		int cur = 0;
		for (int i=0; i < sz; ++i) {
			cur += (1 << i) * (s[i] == '1');
		}
		masks.push_back(cur);
	}
}

int main() {
	read();
	solve();
	return 0;
}
