#include <cstdio>
#include <algorithm>
#define maxn 105
using namespace std;

struct point{
	double x;
	double y;
};


struct fanceT{
	double ax, ay;
	double bx, by;
	bool type;

	fanceT(){
		ax = ay = bx = by = 0;
		type = false;
	}

	fanceT(double _ax, double _ay, double _bx, double _by){
		ax = _ax;
		ay = _ay;
		bx = _bx;
		by = _by;
	}

};

bool isin(point s, fanceT f){
	if(s.x > f.ax && s.x < f.bx && s.y > f.ay && s.y < f.by){
		return true;
	}else return false;

}


fanceT fance[maxn];
point sheep[maxn];
int f, s;
int br;

int main(){

	point tek1 , tek2;


	scanf("%d %d", &f, &s);
	for(int i = 0; i<f; ++i){
		scanf("%lf %lf %lf %lf", &tek1.x, &tek1.y, &tek2.x, &tek2.y);
		if(tek1.x > tek2.x){
			swap(tek1, tek2);
		}

		if(tek1.y > tek2.y){

			fance[i] = fanceT(tek1.x, tek2.y, tek2.x, tek1.y);

		}else{
			fance[i] = fanceT(tek1.x, tek1.y, tek2.x, tek2.y);
		}
	}

	for(int i = 0; i<s; ++i){
		scanf("%lf %lf", &sheep[i].x, &sheep[i].y);
	}

	for(int i = 0; i<s; ++i){
		for(int j = 0; j<f; ++j){
			if( isin(sheep[i], fance[j]) ){
				++br;
				break;
			}
		}
	}

	printf("%d\n", br);





	return 0;
}
