#include <cstdio>
#include <cstring>

void swap( double &a, double &b )
{
	double t = a;
	a = b;
	b = t;
}

const double eps = 1e-7;

int n, m;
double x[1024], y[1024];
double mix[1024], max[1024], miy[1024], may[1024];

int main()
{
	int i, j, k;
	scanf( "%d %d", &n, &m );
	for ( i = 1; i <= n; i++ )
	{
		scanf( "%lf %lf %lf %lf", &mix[i], &miy[i], &max[i], &may[i] );
		if ( mix[i] > max[i] ) swap( mix[i], max[i] );
		if ( miy[i] > may[i] ) swap( miy[i], may[i] );
	}
	
	for ( i = 1; i <= m; i++ )
	{
		scanf( "%lf %lf", &x[i], &y[i] );
	}
	
	k = 0;
		for ( j = 1; j <= m; j++ )
		{
			for ( i = 1; i <= n; i++ )
			{
				if ( ( x[j] > mix[i] + eps ) && ( x[j] + eps < max[i] ) && ( y[j] > miy[i]+eps ) && ( y[j] + eps< may[i] ) )
				{
					//printf( "%lf %lf : %lf %lf %lf %lf\n", x[j], y[j], mix[i], max[i], miy[i], may[i] );
					break;
				}
			}
			if ( i <= n )
			{
				//printf( "%d %d\n", j, i );
				k++;
			}
		}
	printf( "%d\n", k );
	return 0;
}
