#include <cstdio>
#include <cstring>
#include <vector>
//#include <cmath>
#include <algorithm>
using namespace std;

const double eps = 1e-7;

struct point
{
	double x, y;
};

double crp( point o, point a, point b )
{
	return (a.x-o.x)*(b.y-o.y) - (a.y-o.y)*(b.x-o.x);
}

double abs( double xx )
{
	if ( xx < 0 ) return -xx;
	return xx;
}

point sh, e;

bool cmp( point a, point b )
{
	return (crp( sh, a, b ) < 0);
}

int b, s;
bool us[512];
double S[512];
vector<point> z[512];
vector<point> t;

int main()
{
	int i, j, k, b, l;
	int ans = 0;
	point p;
//	double A1, B1, C1, D;
//	double A2, B2, C2;
	
	scanf( "%d %d", &b, &s );
	if ( s >= 14400 ) s = 14400;
	for ( i = 1; i <= b; i++ )
	{
		us[i] = 0;
		scanf( "%d", &k );
		e.x = 0;
		e.y = 0;
		for ( j = 0; j < k; j++ )
		{
			scanf( "%lf %lf", &p.x, &p.y );
			e.x += p.x;
			e.y += p.y;
			z[i].push_back( p );
		}
		e.x = e.x / k;
		e.y = e.y / k;
		
		sh = e;
		sort( z[i].begin(), z[i].end(), cmp );
//		printf( "IN %d : %lf %lf\n", i, e.x, e.y );
		
		S[i] = 0;
		for ( j = 0; j < k; j++ )
		{
			l = j+1;
			if ( l >= k ) l = 0;
//			printf( "AS %d:  %d %d\n", i, j, k );
			S[i] = S[i] + abs( crp( e, z[i][j], z[i][l] ) );
		}
	}
	
	double SS;
	
	for ( i = 1; i <= s; i++ )
	{
		scanf( "%lf %lf", &sh.x, &sh.y );
		for ( j = 1; j <= b; j++ )
		{
			if ( us[j] == 1 ) continue;
			SS = 0;
//			sort( z[j].begin(), z[j].end(), cmp );
			for ( k = 0; k < (int)z[j].size(); k++ )
			{
				if ( ( abs( sh.x-z[j][k].x ) < eps ) && ( abs( sh.y-z[j][k].y ) < eps ) )
				{
					SS = S[j] + S[j];
					ans++;
					break;
				}
				l = k+1;
				if ( l >= (int)z[j].size() ) l = 0;
				SS = SS + abs( crp( sh, z[j][k], z[j][l] ) );
			}
//			printf( "%lf %lf\n", SS, S[i] );
			if ( SS < S[j] + eps )
			{
				us[j] = 1;
				ans++;
			}
		}
	}
	printf( "%d\n", ans );
	return 0;
}
