#include <cstdio>
#include <cstring>
#include <iostream>
using namespace std;

int m, k, n;
int a[64];

long long dp[64][64][2];

long long ia( long long x )
{
	if ( x < 0 ) return -x;
	return x;
}

long long getDP( int la, int p, int t )
{
	if ( la >= n )
	{
		long long mi, mx;
		if ( t == 0 )
		{
			mi = a[p]-k+1;
			if ( mi < 0 ) mi = 0;
			mx = a[p];
		}
		else if ( t == 1 )
		{
			mi = a[p];
			mx = a[p]+k-1;
			if ( mx > m-1 ) mx = m-1;
		}
		if ( la == 1 )
		{
			mi = mx = -1;
			return k;
		}
		
//		printf( "LADP %d %d %d : %lld %lld \n", la, p, t, mi, mx );
		if ( ( mi <= a[la] ) && ( a[la] <= mx ) ) return 0;
		return min( (long long) k, min( ia(a[la]-mi), ia(a[la]-mx) ) );
	}
	if ( dp[la][p][t] != -1 ) return dp[la][p][t];
	long long mi, mx, nmi, nmx;
	if ( t == 0 )
	{
		mi = a[p]-k+1;
		if ( mi < 0 ) mi = 0;
		mx = a[p];
	}
	else if ( t == 1 )
	{
		mi = a[p];
		mx = a[p]+k-1;
		if ( mx > m-1 ) mx = m-1;
	}
	int np, nt;
	long long sol = (1LL<<62);
	if ( la == 1 )
	{
		mi = -1;
		mx = -1;
	}
	for ( np = 1; np <= n; np++ )
	{
		for ( nt = 0; nt < 2; nt++ )
		{
			if ( nt == 0 )
			{
				nmi = a[np]-k+1;
				if ( nmi < 0 ) nmi = 0;
				nmx = a[np];
			}
			else if ( nt == 1 )
			{
				nmi = a[np];
				nmx = a[np]+k-1;
				if ( nmx > m-1 ) nmx = m-1;
			}
			
				if ( ( a[la] >= nmi ) && ( a[la] <= nmx ) )
				{
					if ( mi == -1 )
					{
						sol = min( sol, k + getDP( la+1, np, nt ) );
					}
					else
					{
						sol = min( sol, getDP( la+1, np, nt ) + min((long long) k, ia(nmx-mx)) );
					}
				}
			}
		}
	dp[la][p][t] = sol;
//	cout << "DP " << la << " " << p << " " << t << " " << dp[la][p][t]  << " [ " << mi << " " << mx << " ]"<< endl;
	return dp[la][p][t];
}

int main()
{
	int i;
	
	scanf( "%d %d %d", &m, &k, &n );
	for ( i = 1; i <= n; i++ )
	{
		scanf( "%d", &a[i] );
	}
	memset( dp, -1, sizeof( dp ) );
	
	cout << getDP( 1, 0, 0 ) << endl;
	return 0;
}
