#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

int dmask[] =   { 1 | 2 | 4 | 8 | 16 | 32 ,  //0
                  2 | 4 ,                    //1
                  1 | 2 | 8 | 16 | 64 ,      //2
                  1 | 2 | 4 | 8 | 64 ,       //3
                  2 | 4 | 32 | 64 ,          //4
                  1 | 4 | 8 | 32 | 64 ,      //5
                  1 | 4 | 8 | 16 | 32 | 64 , //6
                  1 | 2 | 4 ,                //7
                  1 | 2 | 4 | 8 | 16 | 32 | 64 , //8
                  1 | 2 | 4 | 8 | 32 | 64        //9
                };

int n;
vector < int > p[32];
int x[32];

void read()
{
    scanf ( "%d" , &n );

    int i , k , tx , t;
    char tmp[16];
    for (k = 0; k < n; ++k)
    {
        tx = 0;
        scanf ( "%s" , tmp );
        for (i = 6; i >= 0; --i)
        {
            tx <<= 1;
            tx |= (tmp[i] == '1');
        }

        x[k] = tx;
    }
}

void check ( int id )
{
    for (int i = 0; i < 10; ++i)
        if ( (x[id] & dmask[i]) == x[id] )
        {
            p[id].push_back ( i );
        }
}

vector < int > tmp;
//vector < vector < int > > vans;

void rec ( int pos )
{
    if ( pos == n )
    {

        int i , j = 0;
        //for (i = (int)tmp.size() - 1; i >= 0; --i , ++j)
        for (i = 0; i < (int)tmp.size(); ++i)
        {
            printf ( "%d" , tmp[i] );
        }
        puts ( "" );

        //vans.push_back ( tmp );

        return;
    }

    for (int i = 0; i < (int)p[pos].size(); ++i)
    {
        tmp.push_back ( p[pos][i] );
        rec ( pos + 1 );
        tmp.pop_back();
    }
}

void solve()
{
    int i , j;
    for (i = 0; i < n; ++i)
        check ( i );

    int res = 1;
    for (i = 0; i < n; ++i)
        res *= (int)p[i].size();

    printf ( "%d\n" , res );
    if ( res > 0 )
        rec ( 0 );

    //printf ( "%d\n" , (int)vans.size() );
    //sort ( vans.begin() , vans.end() );
    /*
    for (i = 0; i < (int)vans.size(); ++i)
    {
        for (j = 0; j < (int)vans[i].size(); ++j)
        {
            printf ( "%d" , vans[i][j] );
        }
        puts ( "" );
    }
    */

}

int main()
{
    read();
    solve();

    return 0;
}
