#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstring>
#include <map>

using namespace std;

map< pair<short, short>, int > g;
#define mp make_pair

int n, m, h;
bool ish[10000];
int hosp[100];
int gg[10000][10000];
int main()
{
    //freopen("in.txt", "r", stdin);

    scanf("%d %d %d", &n, &m, &h);

    memset(ish, 0, sizeof(bool)* 10000);
    for(int i=0; i<h; i++)
    {
        int t;
        scanf("%d", &t);
        hosp[i] = t;
        ish[t] = 1;
    }

    for(int i=0; i<m; i++)
    {
        int a,b,d;
        scanf("%d %d %d", &a, &b, &d);
        g[ make_pair(a,b) ] = d;
        g[ make_pair(b,a) ] = d;
    }

    for(int o=1; o<=n; o++)
    for(int i=1; i<=n; i++)
    for(int j=1; j<=n; j++)
    if(o!=j && o!=i && i!=j)
    {
        int io = g[mp(i, o)];
        int oj = g[mp(o, j)];
        if(io && oj)
        {
            if(!g[mp(i, j)] || io + oj < g[mp(i, j)])
            {
                //cout<<"adding route from "<<i<<" to "<<j<<" with len "<<g[mp(i, o)] + g[mp(o, j)]<<" (mid vertex is "<<o<<", i-o = "<<g[mp(i, o)]<<", o-j = "<<g[mp(o, j)]<<")\n";
                g[mp(i, j)] = io + oj;
                g[mp(j, i)] = io + oj;
            }
        }
    }

    unsigned int bestsum = -1;
    for(int i = 0; i<h; i++)
    {
        int thishosp = hosp[i];
        //cout<<"starting check for hospital at "<<thishosp<<endl;
        unsigned int thissum = 0;
        for(int j=1; j<=n; j++)
        {
            if(ish[j] ) continue;

            //cout<<"adding the path from "<<thishosp<<" to "<<j<<" ( "<<g[mp(thishosp, j)]<<" )"<<endl;
            thissum += g[mp(thishosp, j)];
        }
        //cout<<"the result is "<<thissum<<endl;
        if(bestsum>thissum) bestsum = thissum;
    }

    cout<<bestsum<<endl;
}
