#include<iostream>
using namespace std;

int n , m;
int res;

double min ( double a , double b ) {
	if ( a > b ) return b;
	return a;
}

double max ( double a , double b ) {
	if ( a > b ) return a;
	return b;
}

struct rect {
	double down , up , left , right;
	rect(){}
	rect ( double x1 , double y1 , double x2 , double y2 ) {
		down = min ( y1 , y2 );
		up = max ( y1 , y2 );
		left = min ( x1 , x2 );
		right = max ( x1 , x2 );
	}
	bool query ( double x , double y ) {
		if ( x > left && x < right && y > down && y < up ) return 1;
		return 0;
	}
}fence[1<<7];

int main() {
	cin >> n >> m;
	double x1 , y1 , x2 , y2;
	for ( int i = 0;i < n;++i ) {
		cin >> x1 >> y1 >> x2 >> y2;
		fence[i] = rect ( x1 , y1 , x2 , y2 );
/*		cout << fence[i].down << " ";
		cout << fence[i].up << " ";
		cout << fence[i].left << " ";
		cout << fence[i].right << "\n";
*/	}
	double tekX , tekY;
	for ( int i = 0;i < m;++i ) {
		cin >> tekX >> tekY;
		for ( int j = 0;j < n;++j ) {
			if ( fence[j].query ( tekX , tekY ) ) {
				++res;
				break;
//				cout << "1\n";
			}
//			else cout << "0\n";
		}
	}
	cout << res << endl;
}
