#include<iostream>
#include<cstdio>
//#include<string>
using namespace std;

int output[1<<20];
int outSz;

struct Var {
    int value;
    char name;
    Var ( char a ) {
        value = 0;
        name = a;
    }
}vars[5] = { Var ( 'X' ) , Var ( 'Y' ) , Var ( 'Z' ) , Var ( 'W' ) , Var ( 'V' ) };

struct Line {
    int nextLine;
    string command;
    Line(){}
}lines[1<<14];

Line tekLine;
string::iterator i;

void IgnoreEmptySpace() {
    while ( *i == ' ' && i != tekLine.command.end() ) ++i;
}

void SkipChars ( int count ) {
    for ( int j = 0;j < count;++j ) ++i;
}

int ReadValue() {
    int k = 1;
    if ( *i == '-' ) {
        k = -1;
    }
    if ( *i == '-' || *i == '+' ) ++i;
    IgnoreEmptySpace();
    if ( *i >= 'A' && *i < 'Z' ) {
        for ( int j = 0;j < 5;++j )
            if ( vars[j].name == *i ) {
                ++i;
                IgnoreEmptySpace();
                return vars[j].value * k;
            }
    }

    int res = 0;
    while ( *i >= '0' && *i <='9' ) {
        res *= 10;
        res += ( *i - '0' );
        ++i;
    }
    IgnoreEmptySpace();
    return res * k;
}

bool ReadCondition() {
//  cout << "if ";
    int a = ReadValue();
    char c = *i;
    ++i;
    IgnoreEmptySpace();
    int b = ReadValue();
    SkipChars ( 4 );
    IgnoreEmptySpace();
//  cout << a << c << b << ":";
    if ( c == '=' ) return ( a == b );
    if ( c == '>' ) return ( a > b );
    if ( c == '<' ) return ( a < b );
}

bool ExecuteCommand() {//1-stop 0-not
    if ( *i == 'P' ) {
        SkipChars ( 5 );
        IgnoreEmptySpace();
        int x = ReadValue();
        output[outSz++] = x;
//      cout << "print " << x << endl;
        return 0;
    }
    if ( *i == 'C' ) {
        outSz = 0;
//      cout << "cls\n";
        return 0;
    }
    if ( *i == 'S' ) {
        return 1;
    }

    char a = *i;
    ++i;//x,y,z,w,v
    IgnoreEmptySpace();
    ++i;//=
    IgnoreEmptySpace();
    int x = 0;
    while ( i != tekLine.command.end() ) {
        x += ReadValue();
    }
    for ( int j = 0;j < 5;++j ) {
        if ( vars[j].name == a ) {
            vars[j].value = x;
//          cout << vars[j].name << "=" << x << endl;
            return 0;
        }
    }
}

int ExecuteLine ( int number ) {//-1 - end
    tekLine = lines[number];
    i = tekLine.command.begin();
    ReadValue();
    bool isTrue = 1;
    if ( *i == 'I' ) {
        SkipChars ( 2 );
        IgnoreEmptySpace();
        isTrue = ReadCondition();
//      cout << isTrue << endl;
    }
    if ( isTrue ) {
        if ( *i == 'G' ) {
            SkipChars ( 4 );
            IgnoreEmptySpace();
            int x = ReadValue();
//          cout << "goto " << x << endl;
            return x;
        }
        if ( ExecuteCommand() ) {
//          cout << "stop\n";
            return -1;
        }
    }
//  cout << "goto " << tekLine.nextLine << endl;
    return tekLine.nextLine;
}

//lines[1<<14]
char input[100];

int main() {
    int firstLine = -1;
    int lastLine;
    int prevLine = -1;
    while ( 1 ) {
        cin.getline ( input , 100 );
        if ( input[0] == 'R' && input[1] == 'U' && input[2] == 'N' ) break;
        int number = 0;
        for ( int j = 0;input[j] >= '0' && input[j] <= '9';++j ) {
            number *= 10;
            number += input[j] - '0';
        }
        if ( firstLine == -1 ) firstLine = number;
        if ( prevLine != -1 ) {
            lines[prevLine].nextLine = number;
        }
        lines[number].command = input;
        prevLine = number;
    }
    lines[prevLine].nextLine = -1;
/*  for ( int j = 0;j < ( 1 << 14 );++j ) {
        if ( lines[j].command != "" ) {
            cout << lines[j].command << "->";
            cout << lines[j].nextLine;
            cout << endl;
        }
    }*/
    int currLine = firstLine;
    while ( currLine != -1 ) {
        currLine = ExecuteLine ( currLine );
    }

    for ( int i = 0;i < outSz;++i ) {
        printf ( "%d\n" , output[i] );
    }
    return 0;
}
