#include <iostream>
#include <set>
#include <queue>
#include <vector>
#include <cstdio>
#include <cmath>
#include <string.h>

using namespace std;

#define ll long long

const int MAXN=1001;

struct WALL{
    float x,y,x1,y1;
};

WALL wall[MAXN];
int F,S;
int ans;

float eps=1e-6;

bool check(float x,float y){
    for(int i=0; i<F; i++){
        if(x-min(wall[i].x,wall[i].x1)>eps &&
           max(wall[i].x,wall[i].x1)-x>eps &&
           y-min(wall[i].y,wall[i].y1)>eps &&
           max(wall[i].y,wall[i].y1)-y>eps)
           return true;
    }
    return false;
}

int main(){
    //freopen("sheep.in","r",stdin);
    //freopen("sheep.out","w",stdout);
    scanf("%d %d",&F,&S);
    for(int i=0; i<F; i++){
        scanf("%f %f %f %f",&wall[i].x,&wall[i].y,&wall[i].x1,&wall[i].y1);
    }
    float x,y;
    for(int i=0; i<S; i++){
        scanf("%f %f",&x,&y);
        if(check(x,y))
            ans++;
    }
    printf("%d\n",ans);
    return 0;
}
