#include <cstdio>
#include <algorithm>
using namespace std;

/*
1 3
30 15 -78 95
-24 55
88 -92
-14 95

3 1
10 48 -21 -71
-12 -18 81 19
63 -47 94 92
97 -41
*/

const double eps = 1e-9;

int n , m;
double a[128] , b[128] , c[128] , d[128];
double e[128] , f[128];

void read() {
    int i;

    scanf ( "%d%d" , &n , &m );
    for (i = 1; i <= n; i++) {
        scanf ( "%lf%lf%lf%lf" , &a[i] , &b[i] , &c[i] , &d[i] );

        if ( c[i] < a[i] ) swap ( a[i] , c[i] );
        if ( d[i] < b[i] ) swap ( b[i] , d[i] );
    }

    for (i = 1; i <= m; i++) {
        scanf ( "%lf%lf" , &e[i] , &f[i] );
    }
}

void solve() {
    int i , j;
    int ans = 0;

    for (i = 1; i <= m; i++) {
        for (j = 1; j <= n; j++) {
            if ( a[j] < e[i] - eps && e[i] + eps < c[j] ) {
                if ( b[j] < f[i] - eps && f[i] + eps < d[j] ) {
                    break;
                }
            }
        }

        if ( j <= n ) ++ ans;
    }

    printf ( "%d\n" , ans );
}

int main() {
    read();
    solve();

    return 0;
}
