#include <queue>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

int n , m , k;
int hos[10005];
vector < pair < int , int > > a[10005];

void read() {
    int x , y , z;
    int i;

    scanf ( "%d%d%d" , &n , &m , &k );
    while ( k -- ) {
        scanf ( "%d" , &x );
        hos[x] = 1;
    }

    while ( m -- ) {
        scanf ( "%d%d%d" , &x , &y , &z );
        a[x].push_back ( make_pair ( y , z ) );
        a[y].push_back ( make_pair ( x , z ) );
    }
}

priority_queue < pair < int , int > > pq;
int d[10005];

int dijkstra ( int x ) {
    int i;
    int ans = 0;

    while ( !pq.empty() ) pq.pop();
    for (i = 1; i <= n; i++) d[i] = 1 << 30;

    pq.push ( make_pair ( 0 , x ) );
    d[x] = 0;

    while ( !pq.empty() ) {
        int c = -pq.top().first;
        x = pq.top().second;
        pq.pop();

        if ( d[x] < c ) continue;
        if ( !hos[x] ) {
            ans += c;
        }

        for (i = 0; i < (int)a[x].size(); i++) {
            if ( c + a[x][i].second < d[ a[x][i].first ] ) {
                d[ a[x][i].first ] = c + a[x][i].second;
                pq.push ( make_pair ( -d[ a[x][i].first ] , a[x][i].first ) );
            }
        }
    }

    return ans;
}

void solve() {
    int i;
    int ans = 1 << 30;

    for (i = 1; i <= n; i++) {
        if ( hos[i] ) {
            ans = min ( ans , dijkstra ( i ) );
        }
    }

    printf ( "%d\n" , ans );
}

int main() {
    read();
    solve();

    return 0;
}
