#include <cmath>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

int n , m;
vector < pair < double , double > > a[512];
pair < double , double > b[1 << 20];
int idx;

void read() {
    int i;
    double x , y;
    int z;

    scanf ( "%d%d" , &n , &m );
    for (i = 1; i <= n; i++) {
        scanf ( "%d" , &z );

        while ( z -- ) {
            scanf ( "%lf%lf" , &x , &y );
            a[i].push_back ( make_pair ( x , y ) );
        }
    }

    for (i = 1; i <= m; i++) {
        scanf ( "%lf%lf" , &x , &y );
        b[i] = make_pair ( x , y );
    }
}

double cross ( pair < double , double > a , pair < double , double > b , pair < double , double > c ) {
 //   printf ( "%lf %lf     %lf %lf      %lf %lf\n" , a.first , a.second , b.first , b.second , c.first , c.second );
    return (b.first - a.first) * (c.second - a.second) - (b.second - a.second) * (c.first - a.first);
}

int notequal ( double &a , double b ) {
    if ( fabs ( a ) < 1e-9 ) {
        a = b;
        return 0;
    }
    if ( fabs ( b ) < 1e-9 ) return 0;

    if ( (a > 0) ^ (b > 0) ) return 1;
    a = b;
    return 0;
}

/*
1 3
3
-2 1
8 1
3 4
3 2
10 30
2 37

1 1
3
-2 1
8 1
3 4
200 200
*/


void solve() {
    int i , j , k;
    double sign = 0;
    int ans = 0;

    for (i = 1; i <= n; i++) {
        for (j = 1; j <= m; j++) {
            sign = 0;

            for (k = 0; k < (int)a[i].size(); k++) {
           //     printf ( "%d %d %d   %lf %lf\n" , i , j , k , sign ,  cross ( a[i][k] , a[i][ (k + 1) % (int)a[i].size() ] , b[j] ) );
                if ( notequal ( sign , cross ( a[i][k] , a[i][ (k + 1) % (int)a[i].size() ] , b[j] ) ) ) {
                    break;
                }
            }

            if ( k == (int)a[i].size() )++ ans;
        }

    }

    printf ( "%d\n" , ans );
}

int main() {
//    freopen ( "test1.in" , "r" , stdin );

    read();
    solve();

    return 0;
}
