#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

const int MAX = 100;

long long m , n , k;
long long a[MAX];
long long b[MAX * 2];
long long dp[MAX][MAX * 2];

void read() {
    int i;

    scanf ( "%lld%lld%lld" , &m , &k , &n );
    for (i = 1; i <= n; i++) {
        scanf ( "%d" , &a[i] );
        b[i] = a[i];
        b[n + i] = a[i] - k + 1;
    }
}
/*
10 3 4
0 6 9 2
*/

inline long long inter ( long long x , long long y ) {
    if ( x < y ) {
        return max ( 0LL , x + k - y );
    }
    return max ( 0LL , y + k - x );
}

long long go ( int x , int y ) {
    if ( a[x] < b[y] || b[y] + k - 1 < a[x] ) return m * n;
    if ( x == n ) return 0;

    long long &ans = dp[x][y];
    if ( ans != -1 ) return ans;

    int i;
    ans = m * n;

    for (i = 1; i <= 2 * n; i++) {
        ans = min ( ans , go ( x + 1 , i ) + k - inter ( b[y] , b[i] ) );
    }

 //   printf ( "%d %d   %lld\n" , x , y , ans );

    return ans;
}

void solve() {
    int i;
    long long ans = m * n;

    for (i = 1; i <= 2 * n; i++) {
        if ( b[i] < 0 ) b[i] = 0;
        if ( b[i] > m - k ) b[i] = m - k;
    }

    memset ( dp , -1 , sizeof dp );

    for (i = 1; i <= 2 * n; i++) {
        ans = min ( ans , go ( 1 , i ) + k );
    }

    cout << ans << '\n';
}

int main() {
    read();
    solve();

    return 0;
}
