#include <vector>
#include <cstdio>
#define maxn 10005
#define maxh 105
#define maxpos 2147483000
using namespace std;

struct vert{
	int price;
	int j;
	vert(){
		price = 0;
		j = 0;
	}
	vert(int _j, int _price){
		j = _j;
		price = _price;
	}
};


vector <vert> a[maxn];

bool flag;
int hospital[maxh];
bool ishospital[maxn];
int n, m, h;

int sum[maxn];


void read_data(){
	scanf("%d %d %d", &n, &m, &h);
	for(int i = 1; i<=h; ++i){
		scanf("%d", hospital+i);
		ishospital[hospital[i]] = true;
	}

	int t1, t2, p;
	for(int i = 0; i<m; ++i){
		scanf("%d %d %d", &t1, &t2, &p);
		a[t1].push_back(vert(t2, p));
		a[t2].push_back(vert(t1, p));
	}
}
int sbor(){
	int res = 0;
	for(int i = 1; i<=n; ++i){
		if(!ishospital[i]){
			res += sum[i];
		}
	}
	return res;
}


void dijkstra(int s){
	bool used[maxn];
	sum[s] = 0;

	for(int i = 0; i<=n; ++i){
		sum[i] = maxpos;
		used[i] = false;
	}
	for(int i = 0; i<a[s].size(); ++i){
		sum[a[s][i].j] = a[s][i].price;
	}
	used[s] = true;
	int best, cer;
	flag = true;
	while(flag){
		best = maxpos;
		flag = false;
		for(int i = 1; i<=n; ++i){
			if(!used[i] && sum[i] < best){
				cer = i;
				best = sum[cer];
				flag = true;
				/*printf("%d ", sum[cer]);*/
			}
		}
		if(!flag) continue;
		/*printf("cer is %d\n", cer);*/
		used[cer] = true;

		for(int i = 0; i<a[cer].size(); ++i){
			if(sum[a[cer][i].j] > sum[cer] + a[cer][i].price){
				sum[a[cer][i].j] = sum[cer] + a[cer][i].price;
			}
		}
	}



}



int main(){
	int tek, otg = maxpos;

	read_data();
	for(int i = 1; i<=h; ++i){
		dijkstra(hospital[i]);
		/*for(int j = 1; j<=n; ++j){
			printf("%d --> %d\n", j, sum[j]);
		}printf("\n");*/


		tek = sbor();
		if(tek < otg){
			otg = tek;
		}
	}

	printf("%d\n", otg);

	return 0;
}


