#include <iostream>
#include <string>
#include <vector>
#include <map>

using namespace std;

vector< vector<int> > possibles(10);
vector<int> current;

void print(int number)
{
	if (number > 9)
	{
		if (current.size() > 0)
		{
			for (int i = 0; i < current.size(); ++i)
				cout << current[i];
			cout << endl;
		}
		return;
	}
	if (possibles[number].size() == 0)
	{
		print(number+1);
	}
	else
	{
		for (int i = 0; i < possibles[number].size(); ++i)
		{
			current.push_back(possibles[number][i]);
			print(number+1);
			current.pop_back();
		}
	}
}

int main()
{
	vector<string> alloc;
	int N;
	cin >> N;

	alloc.push_back("1111110");
	alloc.push_back("0110000");
	alloc.push_back("1101101");
	alloc.push_back("1111001");
	alloc.push_back("0110011");
	alloc.push_back("1011011");
	alloc.push_back("1011111");
	alloc.push_back("1110000");
	alloc.push_back("1111111");
	alloc.push_back("1111011");


	for (int i = 0; i < N; ++i)
	{
		string line;
		cin >> line;
		for (int j = 0; j < 10; ++j)
		{
			bool isPossible = true;
			for (int z = 0; z < 7; ++z)
			{
				if (line[z] == '1' && alloc[j][z] == '0')
				{
					isPossible = false;
					break;
				}
			}
			if (isPossible)
			{
				possibles[i].push_back(j);
			}
		}
	}
	int res = 1;
	for (int i = 0; i < possibles.size(); i++)
	{
		if (possibles[i].size() > 0)
			res *= possibles[i].size();
	}
	cout << res << endl;
	print(0);
	return 0;
}