using System;
using System.Linq;
using System.Text;
using System.Collections.Generic;

static class EntryPoint
{
    public struct Fence
    {
        public decimal x, y, sizeX, sizeY;
    }

    public struct Sheep
    {
        public decimal x, y;
    }

    public static void Main(string[] Args)
    {
        int f, s;
        string[] first = Console.ReadLine().Split(' ');
        f = int.Parse(first[0]);
        s = int.Parse(first[1]);

        Fence[] fences = new Fence[f];

        for (int i = 0; i < f; ++i)
        {
            string[] des = Console.ReadLine().Split(' ');
            decimal i1 = decimal.Parse(des[0]);
            decimal i2 = decimal.Parse(des[1]);
            decimal i3 = decimal.Parse(des[2]);
            decimal i4 = decimal.Parse(des[3]);

            fences[i].y = i2 < i4 ? i2 : i4;
            fences[i].x = i1 < i3 ? i1 : i3;
            fences[i].sizeY = (i2 > i4 ? i2 : i4) - fences[i].y;
            fences[i].sizeX = (i1 > i3 ? i1 : i3) - fences[i].x;
        }

        int escaped = 0;
        
        for(int i = 0; i < s; ++ i)
        {
            string[] des = Console.ReadLine().Split(' ');
            Sheep sh;
            sh.x = decimal.Parse(des[0]);
            sh.y = decimal.Parse(des[1]);

            foreach(var fence in fences)
            {
                if (sh.x > fence.x && sh.x < fence.sizeX + fence.x
                    && sh.y > fence.y && sh.y < fence.sizeY + fence.y)
                {
                    escaped++;
                    break;
                }
            }
        }

        Console.WriteLine(escaped);
    }
}