#include <cstdio>
using namespace std;

bool IsSimilar(char* current, char* target)
{
    for (int i = 0; i < 10; ++i)
        if (current[i] == '1' && target[i] == '0')
            return false;
    return true;
}

int** sims;
void PrintNumbers(int* selected, int current, int max)
{
    if (current == max)
    {
		for(int i = 0; i < max; ++ i)
            printf("%d", selected[i]);
		puts("");
        return;
    }

    for(int i = 0; i < 10; ++ i)
    {
        if (sims[current][i] != 0)
        {
            selected[current] = i;
            PrintNumbers(selected, current + 1, max);
        }
    }
}

int main()
{
    char states[][10] = {
        "1111110",
        "0110000",
        "1101101",
        "1111001",
        "0110011",
        "1011011",
        "1011111",
        "1110000",
        "1111111",
        "1111011"
    };

    int n;
	scanf("%d", &n);
    sims = new int*[n];

    int pos = 1;
    int k = 0, currentPos = 0;
	char line[10];

    for (int i = 0; i < n; ++i)
    {
		sims[i] = new int[10];
		scanf("%s", line);

        currentPos = 0;
        //find similarities
        for(int k = 0; k < 10; ++ k)
        {
            if (IsSimilar(line, states[k]))
            {
                sims[i][k] = 1;
                currentPos++;
                continue;
            }
            sims[i][k] = 0;
        }
        pos *= currentPos;
    }
	printf("%d\n", pos);
        
    int* selected = new int[n];
    PrintNumbers(selected, 0, n);
}