#include <cstdio>
#include <cstring>
#include <vector>
#include <map>
using namespace std;

int r_int( int p, char s[] )
{
//	printf( "READ %d %s\n", p, s );
	int x = 0;
	while ( ( s[p] >= '0' ) && ( s[p] <= '9' ) && ( p < (int)strlen( s ) ) )
	{
		x = x*10 + s[p]-'0';
		p++;
	}
//	printf( "EREAD %d\n", x );
	return x;
}

int v, w, x, y, z;

void setV( char a, int v1 )
{
			if ( a == 'V' ) v = v1;
			else if ( a == 'W' ) w = v1;
			else if ( a == 'X' ) x = v1;
			else if ( a == 'Y' ) y = v1;
			else if ( a == 'Z' ) z = v1;
}

int getV( char a )
{
			if ( a == 'V' ) return v;
			else if ( a == 'W' ) return w;
			else if ( a == 'X' ) return x;
			else if ( a == 'Y' ) return y;
			else if ( a == 'Z' ) return z;
		return -1;
}

int getVal( int pos, char s[], int &r )
{
	//printf( "GETVAL %d %s\n", pos, s );
	while ( s[pos] == ' ' ) pos++;
	char b;
	r = 0;
	//printf( "GV %d %c\n", pos, s[pos] );
			if ( ( s[pos] >= 'V' ) && ( s[pos] <= 'Z' ) )
			{
				b = s[pos];
				r = getV( b );
				pos++;
			}
			else if ( s[pos] == '-' )
			{
				r = -r_int(pos+1, s );
				pos++;
				while ( ( s[pos] >= '0' ) && ( s[pos] <= '9' ) && ( pos < (int) strlen( s ) ) )
				{
					pos++;
				}
			}
			else if ( ( s[pos] >= '0' ) && ( s[pos] <= '9' ) )
			{
				r = r_int( pos, s );
				while ( ( s[pos] >= '0' ) && ( s[pos] <= '9' ) && ( pos < (int) strlen( s ) ) )
				{
					pos++;
				}
			}
		// printf( "EVAL %d %d\n", pos, r );
	return pos;
}

map<int,int> mp;
vector<int> out;

int lr;
char row[1024][100020];
char in[10020];

void interpret( int r, int pos )
{
	//fprintf( stderr, "IN %d %d\n", r, pos );
	if ( r > lr ) return;
	while ( row[r][pos] == ' ' ) pos++;
	char a, b, c; // a=b+c
	char si;
	int v1, v2;
// 	fprintf( stderr, "HURKA !! %d %c __ %d %d\n", pos, row[r][pos], (int)row[r][pos], (int)' ' );
	if ( ( row[r][pos] >= 'V' ) && ( row[r][pos] <= 'Z' ) )
	{
	//	fprintf( stderr, "HERE!VXY\n" );
		a = row[r][pos];
		pos++;
		while ( row[r][pos] == ' ' ) pos++;
	//	if ( row[r][pos] != '=' ) fprintf( stderr, "HUrka !\n" );
		pos++;
		while ( row[r][pos] == ' ' ) pos++;
		if ( row[r][pos] == '-' )
		{
			v1 = -r_int( pos+1, row[r] );
			v2 = 0;
			setV( a, v1 );
	//		fprintf( stderr, "HERE! %d %d\n", x, v1 );
			interpret( r+1, 0 );
			return;
		}
		else
		{
			pos = getVal( pos, row[r], v1 );

			while ( ( row[r][pos] == ' ' ) && ( pos < (int) strlen( row[r] ) ) ) pos++;
			
//			printf( "aaaa %d %d %c\n", pos, strlen( row[r] ) );
			if ( pos >= (int) strlen( row[r] ) )
			{
				setV( a, v1 );
//				printf( "TUK?!?!\n" );
				interpret( r+1, 0 );
				return;
			}
			
			if ( row[r][pos] == '+' )
				si = row[r][pos];
			else if ( row[r][pos] == '-' ) si = row[r][pos];
			pos++;
			while ( row[r][pos] == ' ' ) pos++;
			
			pos = getVal( pos, row[r], v2 );
			/*if ( ( row[r][pos] >= 'V' ) && ( row[r][pos] <= 'Z' ) )
			{
				c = row[r][pos];
				v2 = getV( c );
				pos++;
			}
			else if ( ( row[r][pos] >= '0' ) && ( row[r][pos] <= '9' ) )
			{
				v2 = r_int( pos, row[r] );
				while ( ( row[r][pos] >= '0' ) && ( row[r][pos] <= '9' ) && ( pos < (int) strlen( row[r] ) ) )
				{
					pos++;
				}
			}*/
			
//			printf( "HEHEHE %d %c %d\n", v1, si, v2 );
			
			if ( si == '+' )
				setV( a, v1+v2 );
			else if ( si == '-' )
				setV( a, v1-v2 );
		}
	}
	else if ( row[r][pos] == 'I' )
	{
	//	fprintf( stderr, "IF!\n" );
		pos = pos + 2;
		pos = getVal( pos, row[r], v1 );
		while ( row[r][pos] == ' ' ) pos++;
		si = row[r][pos];
		pos++;
		pos = getVal( pos, row[r], v2 );
	//	fprintf( stderr, "IF! %d %c %d\n", v1, si, v2 );
		if ( si == '<' )
		{
			if ( v1 >= v2 )
			{
				interpret( r+1, 0 );
				return;
			}
		}
		if ( si == '=' )
		{
			if ( v1 != v2 )
			{
				interpret( r+1, 0 );
				return;
			}
		}
		if ( si == '>' )
		{
			if ( v1 <= v2 )
			{
				interpret( r+1, 0 );
				return;
			}
		}
		while ( row[r][pos] == ' ' ) pos++;
		if ( row[r][pos] != 'T' )
		{
	//		fprintf( stderr, "KSJNKASND\n" );
		}
		interpret( r, pos+4 );
		return;
	}
	else if ( row[r][pos] == 'G' )
	{
	//	fprintf( stderr, "GOTO!\n" );
		pos = getVal( pos+4, row[r], v1 );
		interpret( mp[v1], 0 );
		return;
	}
	else if ( row[r][pos] == 'C' )
	{
		out.clear();
	//	fprintf( stderr, "CLEAR!\n" );
		interpret( r+1, 0 );
	}
	else if ( row[r][pos] == 'P' )
	{
	//	fprintf( stderr, "PRINT!\n" );
		pos = pos + 5;
		while ( row[r][pos] == ' ' ) pos++;
		a = row[r][pos];
		out.push_back( getV( a ) );
		interpret( r+1, 0 );
	}
	else if ( row[r][pos] == 'S' )
	{
	//	fprintf( stderr, "STOP!\n" );
		return;
	}
}

int main()
{
	int i, j, k;
	
	int cr = 0;
	while ( fgets( in, 10000, stdin ) )
	{
		//fprintf( stderr, "%s", in );
		if ( in[0] == 'R' ) break;
		cr++;
		sscanf( in, "%d", &k );
		mp[k] = cr;
		i = 0;
		while ( ( in[i] >= '0' ) && ( in[i] <= '9' ) )
		{
			i++;
		}
		while ( in[i] == ' ' ) i++;
//		fprintf( stderr, "%s %d\n", in, i );
		for ( j = 0; i < (int)strlen( in )-1; i++,j++ )
		{
			row[cr][j] = in[i];
//			printf( "HAHA %d %c\n", i, row[cr][i] );
		}
		row[cr][j] = '\0';
	//	fprintf( stderr, "%s", row[cr] );
	}
	lr = cr;
	v = w = x = y = z = 0;
	
	interpret( 1, 0 );
	
	//fprintf( stderr, "%d\n", out.size() );
	for ( j = 0; j < (int) out.size(); j++ )
	{
		printf( "%d\n", out[j] );
	}
	return 0;
}
